unit _GRAPH;
{$F+,O+}
interface

uses dos,crt;

type itmap = array[0..63999] of byte;
type bitmap= ^itmap;

type GCHAR = array[0..127,1..8] of byte;
type Gtext = ^gchar;

type RGBpalette = array[0..255] of record
                                     R,G,B : byte;
                                   end;
type palette = ^RGBpalette;

{Rutiny ovladajici grafiku}
procedure _initgraph;
procedure _closegraph;

{Kreslici rutiny}
procedure _drawpixel(X,Y: integer;COL : byte);
procedure _drawmempixel(X,Y: integer;COL : byte);
function  _getmempixel(X,Y : integer): byte;
function  _getpixel(X,Y : integer): byte;
procedure _circle(X,Y,Rad : integer);
procedure _ellipse(X,Y,Xra,Yra: integer);
procedure _line(X1,Y1,X2,Y2 : integer);
procedure _rectangle(X1,Y1,X2,Y2: integer);
procedure _bar(X1,Y1,X2,Y2: integer);
procedure _cleardevice;

{Nastavujici a kontrolujici rutiny}
procedure _setcolor(col : byte);
function  _getcolor : byte;
function  _getmaxX : integer;
function  _getmaxY : integer;
procedure _settexthigh(hi : byte);

{Textove rutiny}
procedure _outtextxyt(X,Y :integer; str :string);
procedure _settextstyle(N : word; var pis : gtext);
procedure _unsettextstyle(var pis : gtext);
procedure _outtextXY(X,Y : integer; S: string; var pis : gtext);

{Binarni rutiny}
procedure _getimage(var p : bitmap;X1,Y1,X2,Y2 : integer);
procedure _putimage(var p : bitmap;X,Y : integer);
function  _imagesize(X1,Y1,X2,Y2: integer): word;

{Rutini pracujici s paletami}
procedure _setRGBpal(CN,R,G,B: byte);
procedure _getRGBpal(CN: byte;var R,G,B: byte);
procedure _initpalette(var pal : palette);
procedure _freepalette(var pal : palette);
procedure _resetscreen(R,G,B : byte);
procedure _fillpalette(var pal :palette;R,G,B : byte);
procedure _savepalette(var pal : palette);
procedure _loadpalette(pal : palette);
procedure _fadedown;
procedure _fadeup(pal : palette);
procedure _qfadedown;
procedure _qfadeup(pal : palette);
procedure _fadeto(pal: palette);
procedure _floadpalette(var f : file;var pal: palette);
procedure _fsavepalette(var f : file;pal: palette);

{Jine rutiny}
function _graphver: string;

const Color : byte=15;
      high : byte= 1;
      wait : real= 1;

var
  regs : registers;
  grres : shortint;
implementation

procedure _INITGRAPH;
begin
  regs.AH:= $0;
  regs.AL:= $13;
  intr($10,regs);
end;
procedure _CLOSEGRAPH;
begin
  regs.AH:= $0;
  regs.AL:= $3;
  intr($10,regs);
end;
procedure _DRAWPIXEL(X,Y: integer;COL : byte);
var N: word;
begin
  regs.AH:=$0c;
  regs.BH:=$0;
  regs.DX:=Y;
  regs.CX:=X;
  regs.AL:=COL;
  intr($10,regs);
end;
procedure _DRAWMEMPIXEL(X,Y: integer;COL : byte);
var N: word;
begin
  {$Q-}
  {$R-}
  if X> _getmaxX then exit;
  if Y> _getmaxY then exit;
  N:= Y*320+X;
  {$Q+}
  {$R+}
  mem[$A000: N]:= COL;
end;
function _GETMEMPIXEL(X,Y : integer): byte;
var  N: word;
begin
  {$Q-}
  {$R-}
  if X> _getmaxX then exit;
  if Y> _getmaxY then exit;
  N:= Y*320+X;
  _GETMEMPIXEL:= mem[$A000: N];
  {$Q+}
  {$R+}
end;
function _GETPIXEL(X,Y : integer): byte;
begin
  regs.AH:=$0d;
  regs.BH:=$00;
  regs.DX:=Y;
  regs.CX:=X;
  intr($10,regs);
  _getpixel:= regs.AL;
end;
procedure _SETCOLOR(col : byte);
begin
  color:= col;
end;
function _GETCOLOR : byte;
begin
  _getcolor:= color;
end;
procedure _CIRCLE(X,Y,Rad : integer);
var
  I,A,B : integer;
begin
  for I:= 0 to 360 do
    begin
      A:= X+ trunc(sin(I)*Rad);
      B:= Y+ trunc(cos(I)*Rad);
      _DrawmemPixel(A,B,color);
    end;
end;
procedure _ELLIPSE(X,Y,Xra,Yra: integer);
var
  I,A,B : integer;
begin
  for I:= 0 to 360 do
    begin
      A:= X+ trunc(sin(I)*Xra);
      B:= Y+ trunc(cos(I)*Yra);
      _DrawmemPixel(A,B,color);
    end;
end;
procedure _line(X1,Y1,X2,Y2: integer);
var
  u,s,v,d1x,d1y,d2x,d2y,m,n : real;
  i : integer;
function sgn(a : real): integer;
  begin
    if a>0 then sgn:=+1;
    if a<0 then sgn:=-1;
    if a=0 then sgn:=0;
  end;
begin
  u:= X2 - X1;
  v:= Y2 - Y1;
  d1x:= SGN(u);
  d1y:= SGN(v);
  d2x:= SGN(u);
  d2y:= 0;
  m:= ABS(u);
  n:= ABS(v);
  if not (M>N) then
    begin
      d2x := 0 ;
      d2y := SGN(v);
      m := ABS(v);
      n := ABS(u);
    end;
  s:= int(m/2);
  for i:= 0 to round(m) do
    begin
      _drawmempixel(X1,Y1,color);
      s := s + n;
      if not (s<m) then
        begin
          s:= s-m;
          X1:= X1 +round(d1x);
          Y1:= Y1 + round(d1y);
       end
          else
       begin
          X1:= X1+ round(d2x);
          Y1:= Y1+ round(d2y);
       end;
  end;
end;
procedure _RECTANGLE(X1,Y1,X2,Y2: integer);
var I : integer;
begin
  I:= 0;
  repeat
  _drawmempixel(X1+I,Y1,color);
  if X1<X2 then inc(I)
           else if X1>X2 then dec(I);
  until X1+I= X2;
  I:= 0;
  repeat
  _drawmempixel(X1+I,Y2,color);
  if X1<X2 then inc(I)
           else if X1>X2 then dec(I);
  until X1+I= X2;
  I:= 0;
  repeat
  _drawmempixel(X1,Y1+I,color);
  if Y1<Y2 then inc(I)
           else if Y1>Y2 then dec(I);
  until Y1+I= Y2;
  I:= 0;
  repeat
  _drawmempixel(X2,Y1+I,color);
  if Y1<Y2 then inc(I)
           else if Y1>Y2 then dec(I);
  until Y1+I= Y2;
end;
procedure _BAR(X1,Y1,X2,Y2: integer);
var I,I1 : integer;
begin
  if Y1< Y2 then
    begin
      for I1:= Y1 to Y2 do
        begin
          I:= 0;
          repeat
          _drawmempixel(X1+I,I1,color);
          if X1<X2 then inc(I)
                   else if X1>X2 then dec(I);
          until X1+I= X2;
        end
    end
          else
    begin
      for I1:= Y1 downto Y2 do
        begin
          I:= 0;
          repeat
          _drawmempixel(X1+I,I1,color);
          if X1<X2 then inc(I)
                   else if X1>X2 then dec(I);
          until X1+I= X2;
        end
    end;
end;
procedure _CLEARDEVICE;
begin
  fillchar(mem[$A000: 0],64000,0);
end;
procedure _OUTTEXTXYt(X,Y :integer; str :string);
var I : byte;
begin
  for I := 1 to ord(str[0]) do
    begin
      regs.ah := 2;
      regs.bh := 0;
      regs.dh := X;
      regs.dl := Y+I;
      Intr(16,regs);
      regs.ah := 9;
      regs.al := ord(str[I]);
      regs.bh := 0;
      regs.bl := color;
      regs.cx := 1;
      Intr(16,regs);
    end;
end;
function byte_word(B1,B2 : byte) : word;
function moc(CIS,mo : byte):word;
var
  I : word;
  X : word;
begin
  if mo= 0 then
    begin
      if cis=2 then moc:= 1
               else moc:= 0;
      exit;
    end;
  X:= 1;
  for I:=1 to mo do X:= X*CIS;
  moc:= X;
end;
var
  X,I : byte;
  bin : array[1..16] of boolean;
  vys : word;
begin
  {$Q-}
  {$R-}
  vys:= 0;
  X:= B1;
  for I:= 16 downto 9 do
    begin
      if X mod 2=0 then bin[I]:= false
                     else bin[I]:= true;
        X:= X div 2;
    end;
  X:= B2;
  for I:= 8 downto 1 do
    begin
      if X mod 2=0 then bin[I]:= false
                     else bin[I]:= true;
        X:= X div 2;
    end;
  for I:=1 to 16 do
    begin
      if bin[I] then X:= 2
                else X:= 0;
      Vys:= Vys+ moc(X,16-I);
    end;
  byte_word:= vys;
end;
procedure _getimage(var p : bitmap;X1,Y1,X2,Y2 : integer);
var
  I,I1 : integer;
  Blo,Bhi : byte;
begin
  {$Q-}
  {$R-}
  if (X2<X1) or (Y2<Y1) then exit;
  Blo:= lo(abs(X2-X1));
  Bhi:= hi(abs(X2-X1));
  p^[1]:= Bhi;
  p^[0]:= Blo;
  Blo:= lo(abs(Y2-Y1));
  Bhi:= hi(abs(Y2-Y1));
  p^[3]:= Bhi;
  p^[2]:= Blo;
  for I:= 0 to Y2-Y1 do
    for I1:= 0 to X2-X1 do p^[I*(X2-X1)+I1+4]:= _getmempixel(X1+I1,Y1+I);
end;
procedure _putimage(var p : bitmap;X,Y : integer);
var
  I,I1 : integer;
  Xa,Ya : word;
begin
  {$Q-}
  {$R-}
  Xa:= byte_word(p^[0],p^[1]);
  Ya:= byte_word(p^[2],p^[3]);
  for I:= 0 to Ya do
    for I1:= 0 to Xa do _drawmempixel(X+I1,Y+I,p^[Xa*I+I1+4]);
end;
function _imagesize(X1,Y1,X2,Y2: integer): word;
begin
  {$Q-}
  {$R-}
  _imagesize:= abs(X2-X1)*abs(Y2-Y1)+4;
end;
function _getmaxX : integer;
begin
  _getmaxX:= 319;
end;
function _getmaxY : integer;
begin
  _getmaxY:= 199;
end;
procedure _setRGBpal(CN,R,G,B: byte);
begin
  port[$3c8]:= CN;
  port[$3c9]:= R;
  port[$3c9]:= G;
  port[$3c9]:= B;
end;
procedure _getRGBpal(CN: byte;var R,G,B: byte);
begin
  port[$3c7]:= CN;
  R:= port[$3c9];
  G:= port[$3c9];
  B:= port[$3c9];
end;
procedure _settextstyle(N : word; var pis : gtext);
var
  S : string;
  f : file;
begin
  str(N,S);
  S:= 'text'+S+'.gch';
  assign(f,S);
  getmem(PIS,1024);
  {$I-}
  reset(f,1024);
  if IOResult<>0 then
    begin
      grres:= -3;
      exit;
    end;
  if filesize(f)<>0 then blockread(f,pis^,1);
  close(f);
  {$I+}
end;
procedure _unsettextstyle(var pis : gtext);
begin
  freemem(PIS,1024);
end;
procedure _outtextXY(X,Y : integer; S: string; var pis : gtext);
var
  POM1 : array[1..8] of byte;
  PIS1 : array[1..8,1..8] of boolean;
  P,POM : byte;
  I1,I,X1 : integer;
  S1 : string;
begin
  if length(S)=0 then exit;
  X1:= 0;
  repeat
  inc(X1);
  P:= ord(S[X1]);
  for I1:=1 to 8 do
    begin
      POM:= PIS^[P,I1];
      for I:= 8 downto 1 do
        begin
          if POM mod 2=0 then pis1[I,I1]:= false
                         else pis1[I,I1]:= true;
          POM:= POM div 2;
        end;
    end;
  for I1:= 1 to 8 do
    for I:=1 to 8 do
      begin
        if pis1[I,I1] then
          begin
            case high of
              1 : _drawmempixel(X+I+X1*10,Y+I1,_getcolor);
              2..10 :
                begin
                  _bar(X+(I*high)+X1*high*10-(high-1),Y+I1*high-(high-1),
                  X+(I*high)+X1*high*10+(high-1),Y+I1*high+(high-1));
                end;
            end;
          end;
      end;
  until X1=length(S);
end;
procedure _settexthigh(hi : byte);
begin
  high:= hi;
end;
procedure _initpalette(var pal : palette);
begin
  if pal= nil then getmem(pal,768);
end;
procedure _resetscreen(R,G,B : byte);
var
  I : byte;
begin
  for I:= 0 to 255 do _setRGBpal(I,R,G,B);
end;
procedure _fillpalette(var pal :palette;R,G,B : byte);
var
  I : byte;
begin
  for I:= 0 to 255 do
    begin
      pal^[I].R:= R;
      pal^[I].G:= G;
      pal^[I].B:= B;
    end;
end;
procedure _freepalette(var pal : palette);
begin
  if pal<> nil then freemem(pal,768);
end;
procedure _savepalette(var pal : palette);
var
  I,R,G,B : byte;
begin
  if pal= nil then exit;
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      pal^[I].R:= R;
      pal^[I].G:= G;
      pal^[I].B:= B;
    end;
end;
procedure _loadpalette(pal : palette);
var
  I,R,G,B : byte;
begin
  if pal= nil then exit;
  for I:= 0 to 255 do
    begin
      R:= pal^[I].R;
      G:= pal^[I].G;
      B:= pal^[I].B;
      _setRGBpal(I,R,G,B);
    end;
end;
procedure _fadedown;
var
  I,R,G,B : byte;
  dal : boolean;
begin
  dal:= false;
  repeat
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if R<>0 then dec(R);
      if G<>0 then dec(G);
      if B<>0 then dec(B);
      _setRGBpal(I,R,G,B);
    end;
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if (R=0) and (G=0) and (B=0) then dal:= true
                                   else dal:= false;
      if dal= false then break;
    end;
  delay(trunc(1*wait));
  until dal;
end;
procedure _qfadedown;
var
  I,R,G,B : byte;
  dal : boolean;
begin
  dal:= false;
  repeat
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if R>10 then R:= R-10
             else R:= 0;
      if G>10 then G:= G-10
             else G:= 0;
      if B>10 then B:= B-10
             else B:= 0;
      _setRGBpal(I,R,G,B);
    end;
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if (R=0) and (G=0) and (B=0) then dal:= true
                                   else dal:= false;
      if dal= false then break;
    end;
  delay(trunc(3*wait));
  until dal;
end;
procedure _fadeup(pal : palette);
var
  I,R,G,B : byte;
  dal : boolean;
begin
  if pal= nil then exit;
  dal:= false;
  repeat
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if R<>pal^[I].R then inc(R);
      if G<>pal^[I].G then inc(G);
      if B<>pal^[I].B then inc(B);
      _setRGBpal(I,R,G,B);
    end;
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if (R=pal^[I].R) and (G=pal^[I].G) and (B=pal^[I].B) then dal:= true
                                                           else dal:= false;
      if dal= false then break;
    end;
  delay(trunc(1*wait));
  until dal;
end;
procedure _qfadeup(pal : palette);
var
  I,R,G,B : byte;
  dal : boolean;
begin
  if pal= nil then exit;
  dal:= false;
  repeat
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if R< pal^[I].R-10 then R:= R+10
                        else R:= pal^[I].R;
      if G< pal^[I].G-10 then G:= G+10
                        else G:= pal^[I].G;
      if B< pal^[I].B-10 then B:= B+10
                        else B:= pal^[I].B;
      _setRGBpal(I,R,G,B);
    end;
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if (R=pal^[I].R) and (G=pal^[I].G) and (B=pal^[I].B) then dal:= true
                                                           else dal:= false;
      if dal= false then break;
    end;
  delay(trunc(3*wait));
  until dal;
end;

procedure _fadeto(pal: palette);
var
  I,R,G,B : byte;
  dal : boolean;
begin
  if pal= nil then exit;
  dal:= false;
  repeat
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if R< pal^[I].R then inc(R);
      if G< pal^[I].G then inc(G);
      if B< pal^[I].B then inc(B);
      if R> pal^[I].R then dec(R);
      if G> pal^[I].G then dec(G);
      if B> pal^[I].B then dec(B);
      _setRGBpal(I,R,G,B);
    end;
  for I:= 0 to 255 do
    begin
      _getRGBpal(I,R,G,B);
      if (R=pal^[I].R) and (G=pal^[I].G) and (B=pal^[I].B) then dal:= true
                                                           else dal:= false;
      if dal= false then break;
    end;
  delay(trunc(1*wait));
  until dal;
end;
procedure _fsavepalette(var f : file;pal: palette);
var
  head : array[1..6] of char;
begin
  head:= 'ZMPpal';
  rewrite(f,1);
  blockwrite(f,head,6);
  blockwrite(f,pal^,768);
  close(f);
end;
procedure _floadpalette(var f : file;var pal: palette);
var
  head : array[1..6] of char;
begin
  {$I-}
  reset(f,1);
  if IOResult<> 0 then
    begin
      grres:= -1;
      exit;
    end;
  {$I+}
  blockread(f,head,6);
  if head<> 'ZMPpal' then
    begin
      close(f);
      grres:= -2;
      exit;
    end;
  blockread(f,pal^,768);
  close(f);
end;

function _graphver: string;
begin
  _graphver:= '1.1';
end;
end.